//-------------------------------------------------------------------------------------
// File : SampleRenderer.h
// Desc : Sample of Renderer implementation
// Copyright(c) Project Asura. All right reserved.
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
// History
//-------------------------------------------------------------------------------------
// <---> 2011/08/09 [Pocol] VK쐬
// <End>

#ifndef __SAMPLE_RENDERER_H__
#define __SAMPLE_RENDERER_H__

//-------------------------------------------------------------------------------------
// Includes
//-------------------------------------------------------------------------------------
#include "asdxDemoApp.h"
#include "asdxModelUtil.h"


//------------------------------------------------------------------------------------
// Defines
//------------------------------------------------------------------------------------
#ifndef AS_ALIGN16
#define AS_ALIGN16 __declspec( align( 16 ) )
#endif


namespace Asura {
namespace SampleProgram {

/////////////////////////////////////////////////////////////////////////
// SampleRenderer class
/////////////////////////////////////////////////////////////////////////
class SampleRenderer : public IRenderer
{
	//-------------------------------------------------------------------
	// list of friend classes and methods
	//-------------------------------------------------------------------
	/* NOTHING */

private:
	//-------------------------------------------------------------------
	// private variables
	//-------------------------------------------------------------------
	Asura::Util::ModelData    mSaturn;		//!< ǂ
	Asura::Util::ModelData    mGround;		//!< n
	D3DXMATRIX				  mWorld;		//!< [hs
	D3DXMATRIX				  mView;		//!< r[s
	D3DXMATRIX				  mProjection;	//!< ˉes
	D3DXVECTOR3				  mViewDir;		//!< xNg
	D3DXVECTOR3				  mLightDir;	//!< Cg̕xNgi̓CgɌj
	ID3D11ShaderResourceView* mpSRV;		//!< VF[_\[Xr[
	ID3D11SamplerState*		  mpSmp;		//!< Tv[Xe[g
	ID3D11Texture2D*          mpTex;		//!< 2eNX`
	ID3D11RenderTargetView*   mpRTV;		//!< _[^[Qbgr[
	ID3D11VertexShader*       mpQuadVS;		//!< fobO`p_VF[_
	ID3D11PixelShader*        mpQuadPS;		//!< fobO`psNZVF[_
	ID3D11Buffer*			  mpQuadVB;		//!< fobO`p_obt@
	uint32_t                  mQuadStride;

	//-------------------------------------------------------------------
	// private methods
	//-------------------------------------------------------------------
	/* NOTHING */

protected:
	//-------------------------------------------------------------------
	// protected variables
	//-------------------------------------------------------------------
	/* NOTHING */

	//-------------------------------------------------------------------
	// protected methods
	//-------------------------------------------------------------------
	/* NOTHING */

public:
	//-------------------------------------------------------------------
	// public variables
	//-------------------------------------------------------------------
	/* NOTHING */

	//-------------------------------------------------------------------
	// public methods
	//-------------------------------------------------------------------
    SampleRenderer();
    virtual ~SampleRenderer();
    bool	OnInit();
    void	OnRelease();
    bool	OnCreateDevice( ID3D11Device* pDevice, const DXGI_SURFACE_DESC* pDesc );
    void	OnDestroyDevice();
	bool    OnResizeSwapChain( ID3D11Device* pDevice, IDXGISwapChain* pSwapChain, const DXGI_SURFACE_DESC *pDesc );
    void	OnUpdate( double time, float elapsedTime );
    void	OnRender( ID3D11Device* pDevice, ID3D11DeviceContext* pImmediateContext, double time, float elapsedTime );
    char*	GetTag() { return "SampleRenderer"; }
};


} // namespace SampleProgram
} // namespace Asura



#endif//__MODEL_RENDERER_H__